#include <iostream>
using namespace std;
//#include "combatant.h"
#include <string>

class Combatant{
 public:
 //Constructor
  Combatant();
  //Alternate, useful constructor!
  Combatant(string, int);
  //Returns the name of the combatant
  string getname();
  //Returns the initiative of the combatant
  int getinitiative();
  //Sets the name of the combatant
  void setname(string);
  //Sets the initiative of the combatant
  void setinitiative(int);
  
  
private:
  int initiative;
  string name;
};



//Item Abstract Data Type definition.
class CList {
public:
	//Constructs a new CList (Empty)
	CList();
	//Constructs an CList with one tree
	CList(Combatant*);
	//Struct for the list's nodes
	struct Node{
		Combatant *cargo;
		Node *ptr;
	};
	//Inserts a node containing combatant x
	void Insert(Combatant*);
	//Removes a named node and returns a list with the node pruned
	CList Remove(string);
	//Returns the tree in the node at the head of the list
	static Combatant head(CList);
	//Returns the tail of the list
	static CList tail(CList x);
	//Returns the Combatant at the head of the list, then removes it from the list non-destructively
	Combatant* pop();
	//Gets size of the list
	int getsize();
	//Determines if a combatant by name "string" is in the list
	bool isin(string);
	//Print the combatants in the list! WOOOO!!!
	void print();

	
private:
	Node *headPtr;
	Node *temp;

};

//Main function for initiative prompt
string prompt_initiative(string);
//Same, but if name is found in initiative order
string prompt_initiative_present(string);

int main(){
 //Initialization of:
  //A list of combatants, ordered by initiative
  CList::CList list_combatants;
  //A temporary name string
  string name = "";
  //A temporary initiative int
  int initiative = 0;
  //Strings for the greeting and name prompts
  string greeting = "Welcome to Joe's Initiative Roller, Mark 1:\nEnter a character's name at the prompt to add them to the intiative order or edit their initiative!\nEnter PRINT to print the current initiative when you're done,\nor enter \"EXIT\" in all caps to exit.";
  string prompt_name = "Enter a name to add/edit (Case Sensitive), PRINT, or EXIT:";
  
  //Print the Greeting
  cout << greeting << endl << endl;
  while (name != "EXIT"){
  	cout << prompt_name << endl;
  	cin >> name;
  	if (name == "PRINT"){
  		list_combatants.print();
  	}
  	if (!list_combatants.isin(name) and name != "PRINT" and name != "EXIT"){
  			cout << prompt_initiative(name) << endl;
  			cin >> initiative;
  			list_combatants.Insert((new Combatant(name,initiative)));
  	}
  	else{
  		if (name != "PRINT" and name != "EXIT"){
  		cout << prompt_initiative_present(name) << endl;
  		cin >> initiative;
  		list_combatants = list_combatants.Remove(name);
  		if (initiative != -1){
  			list_combatants.Insert((new Combatant(name,initiative)));
  		}
  		
  		}
  	}
  }
  			
	
return 0;
}

string prompt_initiative(string n)
{
	return "Enter the initiative number for " + n + ".";
};

string prompt_initiative_present(string n)
{
	return "Enter the new initiative number for " + n + ", or \"-1\" to remove them from the initiative order.";
};

Combatant::Combatant(){
  
};

Combatant::Combatant(string n, int x){
	name = n;
	initiative = x;
}

string Combatant::getname(){
  return name;
};


void Combatant::setname(string n){
	name = n;
};

int Combatant::getinitiative(){
	return initiative;
};

void Combatant::setinitiative(int x){
	initiative = x;
}

//Creates List with headPtr = NULL
CList::CList(){
	headPtr = NULL;
}

//Creates list with Combatant x as sole content
CList::CList(Combatant *x){
	headPtr = NULL;
	Insert(x);
}

//Returns the tree from the node at the head of the list
Combatant CList::head(CList x){
	Combatant r = *x.headPtr->cargo;
	return r;
}

//returns a list with its head at the second node in x
CList CList::tail(CList x){
	CList *r = new CList();
	r->headPtr = x.headPtr->ptr;
	return *r;
}

//Returns the item at the head of the list (lowest number)
//And moves headpointer to the second item, effectively
//deleting it, but not harming the actual nodes.
Combatant* CList::pop(){
	//r = the head's cargo
	Combatant *r = headPtr->cargo;
	headPtr = headPtr->ptr;
	return r;
}


//Adds an Item to the list in appropriate order
void CList::Insert(Combatant *x){
	//Makes a new node, sets it equal to the value, and its pointer equal to NULL.
	Node *nodey = new Node;
	nodey->cargo = x;
	
	
	nodey->ptr = NULL;
	bool exit = false;
	//Sets temp to the value of the headPtr, 
	//and runs it through the list till the
	//item before NULL, at which point it sets
	//the last item's pointer equal to nodey.
	temp = headPtr;
	//If the list is empty, we add it in the front of the list.
	if (temp == NULL){
		headPtr = nodey;
		exit = true;
	}
	else{ 
		//If x is greater than the first item, insert x at front and append the old head.
		if (temp->cargo->getinitiative() <= x->getinitiative()){
			nodey->ptr = headPtr;
			headPtr = nodey;
			exit = true;
		}
	}
	while (exit == false){
		//If the next item is not the last and the item in the next is less
		if (temp ->ptr != NULL && temp->ptr->cargo->getinitiative() <= x->getinitiative()){
			//Set nodey's pointer to point to the next item.
			nodey->ptr = temp->ptr;
			//set the array at temp's referent to point to nodey.
			temp->ptr = nodey;
			exit = true;

		}
		else{
			//If it's the last item, just put Nodey in as last
			if (temp->ptr == NULL){
				temp->ptr = nodey;
				exit = true;
			}
		}
		//Advance the pointer
		temp = temp->ptr;
	}
}

CList CList::Remove(string n){
	temp = headPtr;
	CList *listy = new CList();
	if (temp == NULL)
		return *listy;
	while (temp != NULL){
		if (temp->cargo->getname() != n){
			listy->Insert(temp->cargo);
		}
		temp = temp->ptr;
	}
	return *listy;
}
		
		

//Gets the size of the list
int CList::getsize(){
	int size = 0;
	//Check if list is empty.
	if (headPtr == NULL){
		return size;
	}
	//If not, walk through it till you hit the NULL, incrementing size as you go.
	else {
		temp = headPtr;
		while ( temp != NULL){
			size += 1;
			temp = temp->ptr;
		}
		return size;
	}
}

bool CList::isin(string stringulon){
	//Check if list is empty.
	if (headPtr == NULL){
		return false;
	}
	//If not, walk through it till you hit the NULL
	else {
		temp = headPtr;
		while ( temp != NULL){
			//If the name is the same as stringulon, return True!
		    if (temp->cargo->getname() == stringulon)
		    	return true;
			temp = temp->ptr;
		}
	//Else, return false.
	return false;
	}
}

void CList::print(){
	cout << endl;
	//Check if list is empty.
	if (headPtr == NULL){
		cout << "Empty Initiative: Printing Useless Frippery!" << endl;
	}
	//If not, walk through it till you hit the NULL
	else {
		temp = headPtr;
		while ( temp != NULL){
			//Print the combatant's name and initiative
		   cout << temp->cargo->getname() << " -->\t" << temp->cargo->getinitiative();
		   	//If the next node isn't the last
		   	if (temp->ptr != NULL){
		   		//if there are more nodes with the same initiative
			   	if (temp->cargo->getinitiative() == temp->ptr->cargo->getinitiative()){
			   		//print a comma seperator and keep them on one line
			   		cout <<  ",\t";
			   	}
			   	
			   	else{
			   		//Print an endline
			   		cout << endl;
			   	}
			   	
		   	}
		   	else {
		   		//At the end, print extra endlines for neatness, then exit
		   		cout << endl << endl;
		   		return;
		   	}
		   	temp = temp->ptr;
			
		}
	}

}
